package at.ac.tuwien.sepm.assignment.individual.endpoint.mapper;

import at.ac.tuwien.sepm.assignment.individual.endpoint.dto.OwnerDto;
import at.ac.tuwien.sepm.assignment.individual.entity.Owner;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

@Component
public class OwnerMapper {

    public OwnerDto entityToDto(Owner owner) {
        return new OwnerDto(owner.getId(), owner.getName(), owner.getCreatedAt(), owner.getUpdatedAt());
    }

    public Owner dtoToEntity(OwnerDto owner) {
        return new Owner(owner.getName());
    }

    public List<OwnerDto> entityListToDtoList(List<Owner> ownerEntities) {
        List<OwnerDto> ownerDtos = new ArrayList<>();

        for(Owner owner: ownerEntities) {
            ownerDtos.add(entityToDto(owner));
        }
        return ownerDtos;
    }
}
