package at.ac.tuwien.sepm.assignment.individual.entity;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.sql.Date;
import java.util.Objects;
import at.ac.tuwien.sepm.assignment.individual.enums.ERace;

public class Horse extends BaseEntity {
    private String name;
    private String description;
    private short score;
    private ERace race;
    private Date birthday;
    private String imagePath;
    private Long owner;

    public Horse() {}

    public Horse(String name, String description, short score, Date birthday, ERace race, String imagePath, Long owner) {
        this.name = name;
        this.description = description;
        this.score = score;
        this.birthday = birthday;
        this.race = race;
        this.imagePath = imagePath;
        this.owner = owner;
    }

    public Horse(Long id, String name, String description, short score, Date birthday, ERace race, String imagePath, Long owner) {
        super(id);
        this.name = name;
        this.description = description;
        this.score = score;
        this.birthday = birthday;
        this.race = race;
        this.imagePath = imagePath;
        this.owner = owner;
    }

    public Horse(Long id, String name, String description, short score, Date birthday, ERace race, String imagePath, Long owner, LocalDateTime created, LocalDateTime updated) {
        super(id, created, updated);
        this.name = name;
        this.description = description;
        this.score = score;
        this.birthday = birthday;
        this.race = race;
        this.imagePath = imagePath;
        this.owner = owner;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public short getScore() {
        return score;
    }

    public void setScore(short score) {
        this.score = score;
    }

    public Date getBirthday() {
        return birthday;
    }

    public void setBirthday(Date birthday) {
        this.birthday = birthday;
    }

    public ERace getRace() {
        return race;
    }

    public void setRace(ERace race) {
        this.race = race;
    }

    public String getImagePath() {
        return imagePath;
    }

    public void setImagePath(String imagePath) {
        this.imagePath = imagePath;
    }

    public Long getOwner() {
        return owner;
    }

    public void setOwner(Long owner) {
        this.owner = owner;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Horse)) return false;
        if (!super.equals(o)) return false;
        Horse h = (Horse) o;
        return Objects.equals(name, h.name) &&
            Objects.equals(description, h.description) &&
            Objects.equals(score, h.score) &&
            Objects.equals(birthday, h.birthday) &&
            Objects.equals(race, h.race) &&
            Objects.equals(imagePath, h.imagePath) &&
            Objects.equals(owner, h.owner);
    }

    @Override
    public int hashCode() {
        return Objects.hash(super.hashCode(), name);
    }

    @Override
    protected String fieldsString() {
        DateFormat df = new SimpleDateFormat("yyyy-MM-dd");

        return super.fieldsString() + ", name='" + name + '\'' +
            "description='" + description + '\'' +
            ", score='" + score + '\'' +
            ", birthday='" + df.format(birthday) + '\'' +
            ", race='"  + race + '\'' +
            ", imagePath='" + imagePath + '\'' +
            ", owner='" + owner + '\'';
    }

    @Override
    public String toString() {
        return "Horse{ " + fieldsString() + " }";
    }
}
