package at.ac.tuwien.sepm.assignment.individual.persistence;

import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;

public interface FileDao {
    /**
     * Used for saving files on the local file system
     * @param file file to save
     * @throws IOException if something goes wrong with saving the file
     */
    void save(MultipartFile file) throws IOException;

    /**
     * Used for deleting file from the local filesystem
     * @param fileName file to delete
     * @throws IOException if something goes wrong with deleting the file
     */
    void delete(String fileName) throws IOException;

    /**
     * Used fot getting a file from the local filesystem
     * @param fileName of the file to open
     * @return the file as bytes
     * @throws IOException if something goes wrong during file access
     */
    byte[] get(String fileName) throws IOException;
}
